import _regeneratorRuntime from 'babel-runtime/regenerator';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  color: ', ';\n'], ['\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  color: ', ';\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  width: 2rem;\n  height: 2rem;\n  border: 1px solid #999999;\n  border-radius: 50%;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n'], ['\n  width: 2rem;\n  height: 2rem;\n  border: 1px solid #999999;\n  border-radius: 50%;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n']);

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import React from 'react';
import PropTypes from 'prop-types';
import styled from 'styled-components';

var iconLib = {};
var widthHeightRe = /<svg width="([^"]+)" height="([^"]+)"/;
var viewBoxRe = /viewBox="([^"]+)"/;
var idRe = /<g id="(icon-[^"]+)"/;

var Container = styled.div(_templateObject, function (p) {
  return p.color;
});

var ErrorContainer = styled.div(_templateObject2);

var Icon = function (_React$Component) {
  _inherits(Icon, _React$Component);

  function Icon(props) {
    _classCallCheck(this, Icon);

    var _this = _possibleConstructorReturn(this, (Icon.__proto__ || Object.getPrototypeOf(Icon)).call(this, props));

    _this.state = {
      iconMeta: null
    };
    return _this;
  }

  _createClass(Icon, [{
    key: 'componentDidMount',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        var src, response, contents, vhMatch, viewBoxMatch, idMatch, meta, container;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                src = this.props.src;

                if (!Reflect.has(iconLib, src)) {
                  _context.next = 8;
                  break;
                }

                if (!(typeof iconLib[src].then === 'function')) {
                  _context.next = 5;
                  break;
                }

                _context.next = 5;
                return iconLib[src];

              case 5:
                this.setState({ iconMeta: iconLib[src] });
                _context.next = 26;
                break;

              case 8:
                iconLib[src] = fetch(src, {
                  method: 'GET',
                  credentials: 'include',
                  headers: { accept: 'image/webp,image/apng,image/*,*/*;q=0.8' }
                });

                _context.next = 11;
                return iconLib[src];

              case 11:
                response = _context.sent;
                _context.next = 14;
                return response.text();

              case 14:
                contents = _context.sent;
                vhMatch = contents.match(widthHeightRe);
                viewBoxMatch = contents.match(viewBoxRe);
                idMatch = contents.match(idRe);
                meta = {};

                if (idMatch) {
                  _context.next = 22;
                  break;
                }

                // Error case. Not able to show the icon
                meta.error = true;
                return _context.abrupt('return');

              case 22:
                meta.id = idMatch[1];

                if (vhMatch) {
                  meta.width = vhMatch[1];
                  meta.height = vhMatch[2];
                }

                if (viewBoxMatch) {
                  meta.viewBox = viewBoxMatch[1];
                } else if (vhMatch) {
                  meta.viewBox = '0 0 ' + meta.width.replace('px', '') + ' ' + meta.height.replace('px', '');
                } else {
                  // Error case. Not able to show the icon
                  meta.error = true;
                }

                if (!meta.error) {
                  container = document.querySelector('#react-svg-icon-repo');

                  if (!container) {
                    container = document.createElement('div');
                    container.setAttribute('id', 'react-svg-ikon-repo');
                    container.setAttribute('style', 'display:none');
                    document.body.appendChild(container);
                  }
                  container.innerHTML = container.innerHTML + ' ' + contents;
                  iconLib[src] = meta;
                  this.setState({ iconMeta: meta });
                }

              case 26:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function componentDidMount() {
        return _ref.apply(this, arguments);
      }

      return componentDidMount;
    }()
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          color = _props.color,
          className = _props.className,
          style = _props.style;
      var iconMeta = this.state.iconMeta;

      if (!iconMeta) {
        return null;
      }

      if (iconMeta.error) {
        return React.createElement(
          ErrorContainer,
          null,
          '?'
        );
      }

      var svgStyle = {
        width: iconMeta.width,
        height: iconMeta.height
      };

      return React.createElement(
        Container,
        { color: color, className: className },
        React.createElement(
          'svg',
          { viewBox: iconMeta.viewBox, style: Object.assign({}, svgStyle, style) },
          React.createElement('use', { xlinkHref: '#' + iconMeta.id })
        )
      );
    }
  }]);

  return Icon;
}(React.Component);

export default Icon;


Icon.propTypes = {
  src: PropTypes.string.isRequired,
  color: PropTypes.string,
  className: PropTypes.string,
  style: PropTypes.object // eslint-disable-line react/forbid-prop-types
};

Icon.defaultProps = {
  color: 'black',
  className: null,
  style: {}
};